#property copyright " 2006, RickD"
#property link      "www.e2e-fx.net"



#define major   1
#define minor   0


extern string _Param_Ord_ = "---   ---";


extern int Slippage = 3;
extern int Magic = 100;

int Type;
int HourOpenPos,HourOpenPos1;
int LifeTimeHours;
int StopLoss;
int TakeProfit;


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

void init () {
  if (!IsTesting()) Comment("");
}

void deinit() {
 //----
   
  }
//+------------------------------------------------------------------+
  if (!IsTesting()) Comment("");


void start() {
  
  if (!IsTesting()) Comment("Version: ", major, ".", minor);

  //-----
  
  CheckAge();
  
    
  //-----

  
  
 if (Type == OP_SELL) 
  {
    
    HourOpenPos =8;
    LifeTimeHours =5;
    StopLoss =0;//0
    TakeProfit = 0;
   }
  else if (Type ==OP_BUY)
  {
    
    HourOpenPos1 = 10;
    LifeTimeHours =10;//16
    StopLoss = 0;//110
    TakeProfit =0;//75
  
   
  }
 
  //-----
     if ( Hour() == HourOpenPos1) Type =OP_BUY ;
     if ( Hour() == HourOpenPos) Type = OP_SELL;
      
      if (Minute() > 5) return;
  
  //-----

  int BuyCnt = 0;
  int SellCnt = 0;
  int BuyStopCnt = 0;
  int SellStopCnt = 0;
  
  int cnt = OrdersTotal();
  for (int i=0; i < cnt; i++) {
    if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) continue;
    if (OrderSymbol() != Symbol()) continue;
    if (OrderMagicNumber() != Magic) continue;
   
    
    int type = OrderType();
    if (type == OP_BUY) BuyCnt++;
    if (type == OP_SELL) SellCnt++;
   
  }
  
  //-----
  
 

  //-----
  
  
        
 double price, sl, tp;
  
 
    if (BuyCnt == 0) {
      price = Ask;
      sl = 0;
      tp = 0;
      if (StopLoss > 0) sl = price - StopLoss*Point;
      if (TakeProfit > 0) tp = price + TakeProfit*Point;
      Buy(Symbol(), 0.1, price, sl, tp, Magic, CurTime()+LifeTimeHours*60*60);
    }
 
   
 
 
 
    if (SellCnt == 0) {
      price = Bid;
      sl = 0;
      tp = 0;
      if (StopLoss > 0) sl = price + StopLoss*Point;      
      if (TakeProfit > 0) tp = price - TakeProfit*Point;
      Sell(Symbol(), 0.1, price, sl, tp, Magic, CurTime()+LifeTimeHours*60*60);
    }

   
  }



//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

void CheckAge() 
{
  int cnt = OrdersTotal();
  for (int i=cnt; i>=0; i--) {
    if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) continue;
    if (OrderSymbol() != Symbol()) continue;
    if (OrderMagicNumber() != Magic) continue;
    
    datetime CloseTime = StrToInteger(OrderComment());
    if (CurTime() < CloseTime) continue;
    
    int type = OrderType();
    
    if (type == OP_BUY) CloseOrder(OrderTicket(), OrderLots(), Bid);
    if (type == OP_SELL) CloseOrder(OrderTicket(), OrderLots(), Ask);
    
  
  }
} 


  
  


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

int SleepOk = 2000;
int SleepErr = 6000;

int Buy(string symbol, double Lots, double price, double sl, double tp, int magic, string comment="") {
  RefreshRates();  
  int dig = MarketInfo(symbol, MODE_DIGITS);
  
  price = NormalizeDouble(price, dig);
  sl = NormalizeDouble(sl, dig);
  tp = NormalizeDouble(tp, dig);
    
  string _lot = DoubleToStr(Lots, 1);
  string _price = DoubleToStr(price, dig);
  string _sl = DoubleToStr(sl, dig);
  string _tp = DoubleToStr(tp, dig);

  Print("Buy \"", symbol, "\", ", _lot, ", ", _price, ", ", Slippage, ", ", _sl, ", ", _tp, ", ", magic, ", \"", comment, "\"");

  int res = OrderSend(symbol, OP_BUY,Lots, price, Slippage, sl, tp, comment, magic);
  if (res >= 0) {
    Sleep(SleepOk);
    return (res);
  } 	
   	
 
}
int Sell(string symbol, double Lots, double price, double sl, double tp, int magic, string comment="") {
  RefreshRates();  
  int dig = MarketInfo(symbol, MODE_DIGITS);
 
  price = NormalizeDouble(price, dig);
  sl = NormalizeDouble(sl, dig);
  tp = NormalizeDouble(tp, dig);
    
  string _lot = DoubleToStr(Lots, 1);
  string _price = DoubleToStr(price, dig);
  string _sl = DoubleToStr(sl, dig);
  string _tp = DoubleToStr(tp, dig);

  Print("Sell \"", symbol, "\", ", _lot, ", ", _price, ", ", Slippage, ", ", _sl, ", ", _tp, ", ", magic, ", \"", comment, "\"");
  
  int res = OrderSend(symbol, OP_SELL, Lots, price, Slippage, sl, tp, comment, magic);
  if (res >= 0) {
    Sleep(SleepOk);
    return (res);
  } 	
   	
  
}

bool CloseOrder(int ticket, double lot, double price) {

  RefreshRates();
  if (!OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES)) return(false);
  int dig = MarketInfo(OrderSymbol(), MODE_DIGITS);

  string _lot = DoubleToStr(lot, 1);
  string _price = DoubleToStr(price, dig);

  Print("CloseOrder ", ticket, ", ", _lot, ", ", _price, ", ", Slippage);
  
  bool res = OrderClose(ticket, lot, price, Slippage);
  if (res) {
    Sleep(SleepOk);
    return (res);
  } 	
   	
  
}


